#include <tap.h>
#include "libFireBird.h"

TAP_ID( 0x810714c1 );
#define TAPNAME "CrashTest"
TAP_PROGRAM_NAME(TAPNAME);
TAP_AUTHOR_NAME("R2-D2");
TAP_DESCRIPTION("Causes a crash when the 0 button is pressed, with info in $s1");
TAP_ETCINFO(__DATE__);

void crash1()
{
  register dword s asm ("s1");
  __asm__ __volatile__ (
    "lui %0,0x12ca\n"
    "or  %0,%0,0xfe34\n"
  : : "r"(s));
  TAP_Print("**CRASH**\n");
  // CRASH
  *((dword*)0) = 0;
}

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
  if(event == EVT_KEY)
  {
    if(param1 == RKEY_0)
    {
      register dword s asm ("s1");
      __asm__ __volatile__ (
        "lui %0,0xdead\n"
        "or  %0,%0,0xbeef\n"
      : : "r"(s));
      TAP_Print(TAPNAME ": crashing @ %08x\n", TAP_GetTick());
      crash1(s);
    }
    else if(param1 == RKEY_Exit)
    {
      TAP_Print(TAPNAME ": exit @ %08x\n", TAP_GetTick());
      TAP_Exit();
      param1 = 0;
    }
  }
  return param1;
}

int TAP_Main(void)
{
  TAP_Print(TAPNAME ": start @ %08x\n", TAP_GetTick());
  return 1;
}
